################################################################################################
# R Code for chapter 7 - maximal asymptotic MSE up to second order 
################################################################################################
# M. Brandl 2008
################################################################################################

asMSE0<-function(r,b,vid0)  
  {
   r^2*b^2+vid0^2
  }

asMSE1<-function(n,r,b,vid0,lc1,lid2,vc0,vid1,pm) 
  {
   A1<-((pm*lid2*b^3+2*lc1*b^2)*r^2)+vid0^2*(2*lc1+2*vc0+pm*b*(3*lid2+4*vid1))
   asMSE0(r,b,vid0)+A1*r/sqrt(n)
  }

asMSE2symm<-function(n,r,b,lc2,lid3,vid0,vc1,vid2,r1,pm)
 {
A2<-((1/3*lid3*b^4+lc2*b^3)*r^4+((4*vc1+3*lc2)*vid0^2*b+(2*lid3+3*vid2)*vid0^2*b^2)*r^2+(lid3+3*vid2)*vid0^4+2/3*r1*vid0^3)
 asMSE1(n,r,b,vid0,0,0,0,0,1)+A2/n
 }

##for Hampel-type ICs in Gaussian location model:

Vnorm<-function(c)
		{Anorm(c)^2*(2*pnorm(c)-1-2*dnorm(c)*c+2*c^2*pnorm(-c))} 
		
#Vnorm entspricht dabei v_{id,0}^2 = V_{id}(0)

Anorm<-function(c){(2*pnorm(c)-1)^(-1)}       

lid3norm<-function(c){2*Anorm(c)*c*dnorm(c)}     
vid2norm<-function(c){p<-pnorm(c); d<-dnorm(c);  
                    Z<-6*p-4*p^2-2-2*c*d;
                    N<-2*c^2*(1-p)+2*p-1-2*c*d; Z/N}
                    
r1norm<-function(c)
		{p<-pnorm(c); d<-dnorm(c); A<-Anorm(c); vid0<-sqrt(Vnorm(c));
     3*A^3*(1-2*p+2*c*d)/vid0^3+3/vid0}

lc2norm<-function(c){d<-dnorm(c); A<-Anorm(c);
					A*(2*c^3*d)}
vc1norm<-function(c){d<-dnorm(c); A<-Anorm(c); vid0<-sqrt(Vnorm(c));
					-c^3*d*A^2/vid0^2}


asMSE0.norm<-function(r,c)
			{A<-Anorm(c); b=c*A; vid0<-sqrt(Vnorm(c)); asMSE0(r,b,vid0)}
asMSE1.norm<-function(n,r,c)
			{A<-Anorm(c); b=c*A; vid0<-sqrt(Vnorm(c)); asMSE1(n,r,b,vid0,0,0,0,0,1)}
asMSE2.norm<-function(n,r,c)
			{A<-Anorm(c); b=c*A; vid0<-sqrt(Vnorm(c));
       lid3<-lid3norm(c);vid2<-vid2norm(c);lc2<-lc2norm(c);vc1<-vc1norm(c);
       r1<-r1norm(c); asMSE2symm(n,r,b,lc2,lid3,vid0,vc1,vid2,r1,1)}

